# cortml

YAML loader

## API

### Loading

```js
const cml = require('cortml');

var d = cml.loadFile('data.yaml');

```

### Base

```js

d.setProp('_name', 'Denis Ivanov');
d.setProp({
  _name: 'Denis Ivanov'
});
d.getOptions();

```

### Debug

```js

d.debug(true);

```

### Dump

```js

d.json(key);
d.jsonConsole(key);
d.jsonToFile(filename, key);
d.dump(key);
d.dumpConsole(key);
d.dumpToFile(filename, key);

```

### Events

```js

d.on('name', (...args) => {});
d.emit('name', ...args);

```

### Files

```js

d.__filename
d.__parentFilename
d.getFilename(name)
d.getParentFilename()

```

### Get / Set

```js

d.set(name, value)
d.get(name)
d.has(name)
d.delete(name)
d.update(name, value)

```

### Info

```js

d.findKeys(key)
d.keys(name)

```

### Iterations

```js

d.each(key, (value, key) => {});
d.eachPrimitive(key, (value, key) => {});
d.eachObject(key, (value, key) => {});

```

### Keys

```js

d.getParentKey();
d.getChildKey();

```

### Load / Save

```js

d.save([filename]);
d.load(source, opts, name);
d.loadFile(filename, opts, name);

```

### Structure

```js

d.wrap(data, filename);
d.child(key, filename);
d.getContext(key);
d.getParent(key);

```

### Transform

```js

d.getData(key);
d.clone(key);
d.toArray(key, '_name');

```

### Util

```js

d.flatten(data);

```
