'use strict';

const _ = require('lodash');
const util = require('../util');

const DEFAULT_OPTIONS = {
  debugMode: false,
  jsonOnUpdate: false,
  jsonFilename: null,
  dumpOnUpdate: false,
  dumpFilename: null,
  filename: null,
  parentFilename: null,
  data: {},
  parent: null,
  key: '',
};

const Base = module.exports = class Base {

  constructor (data, opts = {}) {
    var self = this,
      options = _.extend({}, DEFAULT_OPTIONS, opts);
    self.setProp({
      _options: options,
      _opts: options,
    });
    _.extend(self, data);
  }

  setProp (name, value = null, configurable = false, enumerable = false) {
    var self = this;
    if (arguments.length === 1 && name && typeof name === 'object') {
      return _.each(name, (v, n) => self.setProp(n, v));
    }
    Object.defineProperty(self, name, {
      get () {
        return value;
      },
      set (val) {
        value = val;
        return self;
      },
      configurable: configurable,
      enumerable: enumerable,
    });
    return self;
  }

  getOptions () {
    var self = this;
    return self._opts;
  }

}
