'use strict';

const _ = require('lodash');
const Debug = require('./debug');
const util = require('../util');
const fs = require('fs');
const jsyaml = require('../jsyaml');

module.exports = class Dump extends Debug {

  json (name) {
    var self = this;
    return JSON.stringify(self.getData(name), null, 2);
  }

  toJSON (name) {
    var self = this;
    return self.getData(name);
  }

  jsonConsole (name) {
    var self = this;
    console.log(self.json(name));
    return self;
  }

  jsonToFile (filename, name) {
    var self = this;
    fs.writeFileSync(filename, self.json(name));
    return self;
  }

  dump (name) {
    var self = this;
    return jsyaml.dump(self.getData(name));
  }

  dumpConsole (name) {
    var self = this;
    console.log(self.dump(name));
    return self;
  }

  dumpToFile (filename, name) {
    var self = this;
    fs.writeFileSync(filename, self.dump(name));
    return self;
  }

}
