'use strict';

const _ = require('lodash');
const Dump = require('./dump');
const util = require('../util');

module.exports = class Events extends Dump {

  constructor (...args) { super(...args);
    var self = this;
    self.setProp({
      _handlers: {},
    });
  }

  on (name, cb) {
    var self = this;
    self._handlers[name] = self._handlers[name] || [];
    self._handlers[name].push(cb);
    return self;
  }

  emit (name, ...args) {
    var self = this;
    _.each(self._handlers[name], cb => {
      cb(...args);
    });
    return self;
  }

}
