'use strict';

const _ = require('lodash');
const Events = require('./events');
const util = require('../util');
const fs = require('fs');

module.exports = class Files extends Events {

  set __filename (val) {
    var self = this;
    self._opts.filename = val;
    return self;
  }

  get __filename () {
    var self = this;
    return fs.realpathSync(self._opts.filename);
  }

  set __parentFilename (val) {
    var self = this;
    self._opts.parentFilename = val;
    return self;
  }

  get __parentFilename () {
    var self = this;
    return self._opts.parentFilename;
  }

  getFilename (name) {
    var self = this,
      filename = null,
      p = name;
    if (!name) return self.__filename;
    while (!filename && p) {
      if (self.has(p) && self.get(p).__filename) {
        return self.get(p).__filename;
      }
      p = p
        .split('.')
        .slice(0, -1)
        .join('.');
    }
    return filename;
  }

  getParentFilename () {
    var self = this;
    return self._opts.parentFilename;
  }

}
