'use strict';

const _ = require('lodash');
const GetSet = require('./get-set');
const util = require('util');

module.exports = class Info extends GetSet {

  findKeys (t) {
    var self = this,
      text = t.toLowerCase();
    return self
      .keys()
      .map(key => key.toLowerCase())
      .filter(key => key.indexOf(text) > -1);
  }

  keys (key) {
    var self = this,
      item = self.get(key);
    if (!key) {
      return _.keys(self.flatten(self));
    }
    return _
      .keys(self.flatten(item))
      .map(
        p => `${item._opts.key
          ? item._opts.key + '.'
          : ''}${p}`
      );
  }

}
