'use strict';

const _ = require('lodash');
const jsyaml = require('../jsyaml');
const Iterations = require('./iterations');
const schema = require('../schema');
const util = require('../util');
const fs = require('fs-extra');

module.exports = class LoadSave extends Iterations {

  save (f) {
    var self = this,
      filename = f || self.getFilename();
    if (!filename) { return self; }
    self.dumpToFile(filename);
    return self;
  }

  load (source, opts = {}, name = '') {
    var self = this,
      raw = jsyaml.load(source, _.extend({ schema }, opts)),
      data = name ? _.get(raw, name) : raw;
    _.extend(self, data);
    return self;
  }

  loadFile (file, opts = {}, name = '') {
    var self = this,
      filename = util.pickExt(file),
      source = fs.readFileSync(filename, 'utf-8');
    self.load(source, _.extend(opts, {
      filename,
    }), name);
    self._opts.filename = filename;
    return self;
  }

}
