'use strict';

const _ = require('lodash');
const Structure = require('./structure');
const util = require('../util');
const Base = require('./base');

module.exports = class Transform extends Structure {

  getData (key) {
    var self = this,
      data = key ? _.extend({}, self._get(key)) : _.extend({}, self);
    _.each(data, (val, name) => {
      if (val instanceof Base) {
        data[name] = val.getData();
      };
    });
    return data;
  }

  clone (key) {
    var self = this;
    if (!key) return _.child();
    return self.get(key).child();
  }

  toArray (key, name = 'name') {
    var self = this,
      val = key ? self.get(key) : self;
    if (typeof val !== 'object') {
      return null;
    }
    return util.objectsToArray(val, name);
  }

}
