'use strict';

const _ = require('lodash');

const Type = require('./type');
const jsyaml = require('./jsyaml');
const types = require('./types');

module.exports = loadCortSchema();

function loadCortSchema() {
  var defaultTypes = _.clone(jsyaml.TYPES),
    cortTypes = _
      .values(types)
      .map(Pattern => new Type(Pattern)),
    schema = jsyaml.Schema.create(
      defaultTypes.concat(cortTypes)
    );
  return schema;
}
