'use strict';

const _ = require('lodash');
const fs = require('fs');
const path = require('path');
const bank = require('../bank');
const util = require('../util');

module.exports = class RequiredModule {

  get options() {
    return {
      tag: '!include',
      kind: 'scalar'
    };
  }

  getAbsoluteFilename (rel, state) {
    var self = this;
    return util.pickExt(
      path.resolve(path.dirname(state.filename), rel)
    );
  }

  resolve (rel, state) {
    var self = this;
    return !!self.getAbsoluteFilename(rel, state);
  }

  construct (rel, state) {
    const cml = require('../index');
    
    var self = this,
      filename = self.getAbsoluteFilename(rel, state);
    if (!filename) {
      return null;
    }
    bank.requires[state.filename] = bank.requires[state.filename] || {};
    bank.requires[state.filename][filename] = true;

    let data = cml.loadFile(filename);
    data.__parentFilename = state.filename;
    data.__filename = filename;
    return data;
  }

}
