'use strict';

const _ = require('lodash');
const fs = require('fs');
const path = require('path');
const bank = require('../bank');
const util = require('../util');

module.exports = class RequiredModule {

  get options() {
    return {
      tag: '!require',
      kind: 'scalar'
    };
  }

  // getAbsoluteFilename (rel, state) {
  //   var self = this;
  //   return util.pickExt(
  //     path.resolve(path.dirname(state.filename), rel)
  //   );
  // }
  //
  // resolve (rel, state) {
  //   var self = this;
  //   return !!self.getAbsoluteFilename(rel, state);
  // }

  construct (rel, state) {
    var self = this,
      filename = path.resolve(
        path.dirname(state.filename),
        rel
      ),
      moduleData;

    try {
      moduleData = require(filename);
    } catch(err) {
      moduleData = {};
    }
    
    return moduleData;
  }

}
