'use strict';

const _ = require('lodash');
const fs = require('fs');
const path = require('path');

const util = require('./index');

module.exports = {

  readdirRecursive, readFile, read: readFile,
  existsFile, existsDir, exists,

};

function readFile(filename) {
  return fs.readFileSync(filename, 'utf-8');
}

function readdirRecursive(dirname) {
  var self = this,
    files = [];
  _.each(fs.readdirSync(dirname), file => {
    var filename = path.join(dirname, file);
    files.push(filename);
    if (util.existsDir(filename)) {
      files = files.concat(self.readdirRecursive(filename));
    }
  });
  return files;
}

function exists(filename) {
  return fs.existsSync(filename);
}

function existsFile(filename) {
  return fs.existsSync(filename) && fs.statSync(filename).isFile();
}

function existsDir(filename) {
  return fs.existsSync(filename) && fs.statSync(filename).isDirectory();
}
